/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	kubeovnv1 "github.com/kubeovn/kube-ovn/pkg/apis/kubeovn/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeProviderNetworks implements ProviderNetworkInterface
type FakeProviderNetworks struct {
	Fake *FakeKubeovnV1
}

var providernetworksResource = schema.GroupVersionResource{Group: "kubeovn.io", Version: "v1", Resource: "provider-networks"}

var providernetworksKind = schema.GroupVersionKind{Group: "kubeovn.io", Version: "v1", Kind: "ProviderNetwork"}

// Get takes name of the providerNetwork, and returns the corresponding providerNetwork object, and an error if there is any.
func (c *FakeProviderNetworks) Get(ctx context.Context, name string, options v1.GetOptions) (result *kubeovnv1.ProviderNetwork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(providernetworksResource, name), &kubeovnv1.ProviderNetwork{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.ProviderNetwork), err
}

// List takes label and field selectors, and returns the list of ProviderNetworks that match those selectors.
func (c *FakeProviderNetworks) List(ctx context.Context, opts v1.ListOptions) (result *kubeovnv1.ProviderNetworkList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(providernetworksResource, providernetworksKind, opts), &kubeovnv1.ProviderNetworkList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kubeovnv1.ProviderNetworkList{ListMeta: obj.(*kubeovnv1.ProviderNetworkList).ListMeta}
	for _, item := range obj.(*kubeovnv1.ProviderNetworkList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested providerNetworks.
func (c *FakeProviderNetworks) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(providernetworksResource, opts))
}

// Create takes the representation of a providerNetwork and creates it.  Returns the server's representation of the providerNetwork, and an error, if there is any.
func (c *FakeProviderNetworks) Create(ctx context.Context, providerNetwork *kubeovnv1.ProviderNetwork, opts v1.CreateOptions) (result *kubeovnv1.ProviderNetwork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(providernetworksResource, providerNetwork), &kubeovnv1.ProviderNetwork{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.ProviderNetwork), err
}

// Update takes the representation of a providerNetwork and updates it. Returns the server's representation of the providerNetwork, and an error, if there is any.
func (c *FakeProviderNetworks) Update(ctx context.Context, providerNetwork *kubeovnv1.ProviderNetwork, opts v1.UpdateOptions) (result *kubeovnv1.ProviderNetwork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(providernetworksResource, providerNetwork), &kubeovnv1.ProviderNetwork{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.ProviderNetwork), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeProviderNetworks) UpdateStatus(ctx context.Context, providerNetwork *kubeovnv1.ProviderNetwork, opts v1.UpdateOptions) (*kubeovnv1.ProviderNetwork, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(providernetworksResource, "status", providerNetwork), &kubeovnv1.ProviderNetwork{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.ProviderNetwork), err
}

// Delete takes name of the providerNetwork and deletes it. Returns an error if one occurs.
func (c *FakeProviderNetworks) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(providernetworksResource, name), &kubeovnv1.ProviderNetwork{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeProviderNetworks) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(providernetworksResource, listOpts)

	_, err := c.Fake.Invokes(action, &kubeovnv1.ProviderNetworkList{})
	return err
}

// Patch applies the patch and returns the patched providerNetwork.
func (c *FakeProviderNetworks) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *kubeovnv1.ProviderNetwork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(providernetworksResource, name, pt, data, subresources...), &kubeovnv1.ProviderNetwork{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.ProviderNetwork), err
}
